<template>
  <div id="createPublicationRequest">
    <CoscineHeadline :headline="$t('page.dataPublication.title')" />

    <!-- Navigation Tabs -->
    <b-tabs v-model="currentTab" justified class="mb-4">
      <b-tab
        v-for="(tab, index) in tabs"
        :key="index"
        :disabled="!tab.active"
        :title="tab.title"
        @click.prevent="toTab(tab)"
      />
    </b-tabs>

    <!-- Tab Content -->
    <b-row>
      <div class="col-sm-2" />
      <div class="col-sm-8">
        <DataPublication
          v-if="currentTab === 0"
          v-model="publicationRequestForCreation"
          @valid="setNextTab"
          @next="next"
        />
        <DataPublicationProjectData
          v-else-if="currentTab === 1"
          v-model="publicationRequestForCreation"
          :message="publicationRequestForCreation.message"
          :resource-ids="publicationRequestForCreation.resourceIds"
          @update:message="publicationRequestForCreation.message = $event"
          @update:resourceIds="
            publicationRequestForCreation.resourceIds = $event
          "
          @valid="setNextTab"
          @next="next"
        />
        <DataPublicationSummary
          v-else-if="currentTab === 2"
          v-model="publicationRequestForCreation"
          :tabs="tabs"
          :message="publicationRequestForCreation.message"
          @update:message="publicationRequestForCreation.message = $event"
          @back="back"
        />
      </div>
      <div class="col-sm-2" />
    </b-row>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

// import the store for current module
import useProjectStore from "../store";
import useUserStore from "@/modules/user/store";
import useMainStore from "@/store/index";
import DataPublication from "./components/data-publication/DataPublication.vue";
import DataPublicationProjectData from "./components/data-publication/DataPublicationProjectData.vue";
import DataPublicationSummary from "./components/data-publication/DataPublicationSummary.vue";
import type { PublicationRequestTab } from "../types";
import type {
  UserDto,
  PublicationRequestForCreationDto,
  ProjectDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: {
    DataPublication,
    DataPublicationProjectData,
    DataPublicationSummary,
  },
  setup() {
    const projectStore = useProjectStore();
    const userStore = useUserStore();
    const mainStore = useMainStore();

    return { projectStore, userStore, mainStore };
  },

  data() {
    return {
      currentTab: 0,
      tabsStatus: [true, false, false],
      publicationRequestForCreation: {
        publicationServiceId: "",
        resourceIds: [],
        message: "",
      } as PublicationRequestForCreationDto,
      currentLanguage: "" as string,
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    tabs(): PublicationRequestTab[] {
      // Order does matter
      return [
        {
          title: this.$t("page.dataPublication.tab1").toString(),
          active: true,
          step: "dataPublication",
          hidden: false,
        },
        {
          title: this.$t("page.dataPublication.tab2").toString(),
          active: this.tabsStatus[1],
          step: "dataPublicationProjectData",
          hidden: false,
        },
        {
          title: this.$t("page.dataPublication.tab3").toString(),
          active: this.tabsStatus[2],
          step: "dataPublicationSummary",
          hidden: false,
        },
      ] as PublicationRequestTab[];
    },
    user(): UserDto | null | undefined {
      return this.userStore.user;
    },
    email(): string | undefined {
      if (this.user?.emails) {
        return this.user.emails
          .map((user) => (user.email ? user.email : "")) // Extract email display name, could contain empty strings
          .filter((n) => n) // Filter out empty strings, if any
          .at(0);
      }
      return "";
    },
  },

  async created() {
    await this.fetchData();
  },

  methods: {
    async fetchData() {
      // Load Project Disciplines if not present
      if (this.projectStore.disciplines === null) {
        await this.projectStore.retrieveDisciplines();
      }
      // Load Publication Services if not present
      if (this.projectStore.publicationAdvisoryServices === null) {
        this.currentLanguage = this.mainStore.coscine.locale;
        await this.projectStore.retrievePublicationOrganizations(
          this.currentLanguage,
        );
      }
    },
    back() {
      this.currentTab -= 1;
    },
    next() {
      this.currentTab += 1;
    },
    toTab(tab: PublicationRequestTab) {
      this.currentTab = this.tabs.findIndex((t) => t.step === tab.step);
    },
    setNextTab(active: boolean) {
      this.tabsStatus.splice(this.currentTab + 1, 1, active);
    },
  },
});
</script>
